# Intel's Cache Allocation Technology
Intel’s Cache Allocation Technology (CAT) helps address shared resource concerns by providing software control of where data is allocated into the last-level cache (LLC), enabling isolation and prioritization of key applications.

## Acronyms
**CAT :** Cache Allocation Technology

**CMT :** Cache Monitoring Technology

**CDP :** Code and Data prioritization

**CLOS/COS :** Class of service


## Commands

### Monitoring

- Show current configuration

```bash
sudo pqos -s -v
```

- Monitor LLC occupancy for group of cores (e.g. [0-2] and [3-5])

```bash
sudo pqos -m "all:[0-2],[3-5];"
```

### Usage

- Set COS 1 to the first 4 cache ways and COS 2 to the next 8 cache ways:

```bash
pqos -e "llc:1=0x000f;llc:2=0x0ff0;"
```

- Set COS 1 on all sockets, COS 2 on socket 0 and 1 and COS 3 on sockets 2 to 3:

```bash
pqos -e "llc:1=0x000f;llc@0,1:2=0x0ff0;llc@2-3:3=0x3c"
```

- Associate cores 0, 2, and 6 to 10 with COS 1 and core 1 to COS 2:

```bash
pqos -a "llc:1=0,2,6-10;llc:2=1;"
```


## F.A.Q.

###### *When I try to run the utility I get the following error messages:*

> WARN: Error opening file '/dev/cpu/0/msr'!

> ERROR: CDP detection error!

> ERROR: Fatal error encounter in CAT discovery!

> ERROR: discover_capabilities() error 1

> Error initializing PQoS library!

Run the following command:

```bash
sudo modprobe msr
```
